#include <bits/stdc++.h>

using namespace std;

int main()
{
    int h, n, i, j, zbir=0, pocetna=-1;

    cin>>h>>n;

    int stena[h][n], voda[n];

    for(i=0; i<n; i++)
    {
        voda[i]=1;
    }
    for(i=0; i<h; i++)
    {
        for(j=0; j<n; j++)
        {
            cin>>stena[i][j];
        }
    }

    for(i=0; i<h; i++)
    {
        for(j=0; j<n; j++)
        {
            if(stena[i][j]==0)
            {
                if(pocetna==-1)
                {
                    pocetna=j;
                    zbir=0;
                }
                zbir=zbir+voda[j];
                voda[j]=0;
                if(j==n-1)
                {
                    voda[pocetna-1]=voda[pocetna-1]+zbir;
                    zbir=0;
                    pocetna=-1;
                }
            }
            else
            {
                if((j!=0)&&(stena[i][j-1]==0))
                {
                    if(pocetna==0)
                    {
                        voda[j]=voda[j]+zbir;
                        zbir=0;
                        pocetna=-1;
                    }
                    else
                    {
                        if(zbir%2==1)
                        {
                            if(i%2==0)
                            {
                                voda[pocetna-1]=voda[pocetna-1]+1;
                                zbir=zbir-1;
                            }
                            else
                            {
                                voda[j]=voda[j]+1;
                                zbir=zbir-1;
                            }
                        }
                        voda[pocetna-1]=voda[pocetna-1]+(zbir/2);
                        voda[j]=voda[j]+(zbir/2);
                        zbir=0;
                        pocetna=-1;
                    }
                }
            }
        }
    }


    for(i=0; i<n; i++)
    {
        cout<<voda[i]<<" ";
    }
    cout<<endl;

    return 0;
}